// CPhaseUnwrap.c MEX file to find phase and unwrap
#include "mex.h"
#include <math.h>
#define nsp_UsesAll	// uses Intel library functions
#include "nsp.h"
/* this is a mex function specifically designed for use with reSynth.m */
/* error trapping is kept to a minimum to enhance speed */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	double *imag, *real, *phase, *dp_corr, dp, dps, dp_corr_cum,inv_2PI,modTemp;
	int n,N,iModTemp;
	// variables passed from MATLAB
	imag = mxGetPr(prhs[0]);
	real = mxGetPr(prhs[1]);
	N = mxGetN(prhs[0]);
	inv_2PI = 1/NSP_2PI;

	// create phase array
	dp_corr = (double *)mxMalloc((N-1)*sizeof(double));

	// pass back to MATLAB
	plhs[0] = mxCreateDoubleMatrix(1,N,mxREAL);
	phase = mxGetPr(plhs[0]);

	// find phase (atan2) first
	nspdbrPhase(real,imag,phase,N);

	// now unwrap, based on MATLAB unwrap function
	dp_corr_cum = 0.0;
	for (n=0;n<(N-1);n++)	{
		dp = phase[n+1]-phase[n];
		modTemp = fmod(dp+NSP_PI,NSP_2PI);
		if (modTemp<0) modTemp = NSP_2PI+modTemp;
		dps = modTemp-NSP_PI;
		if (dps==(-1.0 * NSP_2PI) && dp>0) dps = NSP_PI;
		dp_corr[n] = dps-dp;
		if (fabs(dp)<NSP_PI) dp_corr[n] = 0;
	}
	
	for (n=0;n<(N-1);n++)	{
		dp_corr_cum += dp_corr[n];
		phase[n+1] += dp_corr_cum;
	}

	mxFree(dp_corr);
}

	