// CSpectralSubtract.c MEX file to perform spectral subtraction
#include "mex.h"
#include <math.h>
#define nsp_UsesAll	// uses Intel library functions
#include "nsp.h"
/* this is a mex function specifically designed for use with reSynth.m */
/* error trapping is kept to a minimum to enhance speed */
void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	// arrays from MATLAB
	double *im,*re,*sineIndex,*residualRange,*complexSize,*recipBinWidth,*df;

	// internal variables
	double temp;
	int iComplexSize,n,N,lower,upper,c,ix;

	// get MATLAB pointers
	im = mxGetPi(prhs[0]);
	re = mxGetPr(prhs[0]);
	sineIndex = mxGetPr(prhs[1]);
	residualRange = mxGetPr(prhs[2]);
	complexSize = mxGetPr(prhs[3]);
	recipBinWidth = mxGetPr(prhs[4]);
	df = mxGetPr(prhs[5]);

	iComplexSize = (int)complexSize[0];
	N = mxGetN(prhs[1]);

	for (n=0;n<N;n++)	{
		ix = (int)sineIndex[n]-1;	//MATLAB arrays start at 1
		temp = abs(df[ix]*recipBinWidth[0]*0.5);
		lower = ix-(int)residualRange[0]-(int)temp;
		upper = ix+(int)residualRange[0]+(int)temp;
		if (upper>iComplexSize)
			upper = iComplexSize;
		if (lower<0)
			lower = 0;
		for (c=lower;c<upper;c++)	{
			im[c] = 0.0;
			re[c] = 0.0;
		}
	}
}

